

coin(10).
coin(5).
coin(2).
coin(1).
% coin(0).

%%% Straightforward approach
change(S) :- coin(X), coin(Y), coin(Z), coin(U), coin(V), S is X+Y+Z+U+V,
write([X,Y,Z,U,V]),nl.


num(0).
num(1).
num(2).
num(3).
num(4).
num(5).

%%% Predefined coins 
change_nums_coins(S) :- num(N1), num(N2), num(N3), num(N4), 
                 coin(C1), coin(C2), coin(C3), coin(C4), 
                 SUM is C1*N1 + C2*N2 + C3*N3 + C4*N4,
                 S =:= SUM,
                 write([N1/C1,N2/C2,N3/C3,N4/C4]),nl.

%%% Fixed Coins
change_nums_fix(S) :- num(N1), num(N2), num(N3), num(N4),
                 SUM is 10*N1 + 5*N2 + 2*N3 + 1*N4,
                 S =:= SUM,
                 write([N1/10,N2/5,N3/2,N4/1]),nl.

%%% Greedy Approach
change_rec(0) :- write('Success'),nl,!.
change_rec(S):-
  coin(C),
  S >= C, !,
  SN is S-C,
  write('Coin: '), write(C), write('   New Change:') , write(SN), nl,
  change_rec(SN).

%%% Greedy iterative approach
change_iter(R,L):- do(R,[],L).

do(0,L,L) :- !.

do(R,A,L):- 
   coin(M), M =< R, RM is R-M,
   do(RM,[M|A],L).
  
  

